require 'open-uri'
require 'openssl'
require 'json'

module Geckodriver
  class Helper
    class GeckoReleasePageParser

      GIT_API_URL = 'https://api.github.com/repos/mozilla/geckodriver/releases'
      GIT_TOKEN = '6328fd0d8cb61bb43cb0ec756226253821e03527'

      attr_reader :platform

      def initialize(platform)
        @platform = platform
      end

      def download_url(version)
        output = open(GIT_API_URL, {ssl_verify_mode: OpenSSL::SSL::VERIFY_NONE})
        releases = JSON.parse(output.read)
        releases.each do |release|
          if release['html_url'].include?(version)
            assets = release['assets']
            assets.each do |asset|
              link = asset['browser_download_url']
              if link.include? platform
                return link
              end
            end
          end
        end
      end

    end
  end
end

